// Contexte graphique
const cvs = document.getElementById("zone_dessin");
cvs.width = 700;
cvs.height = 350;
const ctx = cvs.getContext("2d");

import {Scene} from "./mario_scene.js";
import {Clavier} from "./mario_clavier.js";
import {Mario} from "./mario_personnage.js";
import {Bloc} from "./mario_objet.js";
import {Tuyau} from "./mario_objet.js";
import {Piece} from "./mario_objet.js";
import {Champ} from "./mario_personnage.js";
import {Tortue} from "./mario_personnage.js";

const sonPiece = new Audio();
sonPiece.src = "../audio/piece.wav";
const musiqueFinGagne = new Audio();
musiqueFinGagne.src = "../audio/partieGagnee.wav";
const sonEcrasePersonnage = new Audio();
sonEcrasePersonnage.src = "../audio/ecrasePersonnage.wav";

const tuyauRouge1 = new Tuyau(600, 230);
const tuyauRouge2 = new Tuyau(1000, 230);
const tuyauRouge3 = new Tuyau(1600, 230);
const tuyauRouge4 = new Tuyau(1900, 230);
const tuyauRouge5 = new Tuyau(2500, 230);
const tuyauRouge6 = new Tuyau(3000, 230);
const tuyauRouge7 = new Tuyau(3800, 230);
const tuyauRouge8 = new Tuyau(4500, 230);

const bloc1 = new Bloc(400, 180);
const bloc2 = new Bloc(1200, 180);
const bloc3 = new Bloc(1270, 170);
const bloc4 = new Bloc(1340, 160);
const bloc5 = new Bloc(2000, 180);
const bloc6 = new Bloc(2600, 160);
const bloc7 = new Bloc(2650, 180);
const bloc8 = new Bloc(3500, 160);
const bloc9 = new Bloc(3550, 140);
const bloc10 = new Bloc(4000, 170);
const bloc11 = new Bloc(4200, 200);
const bloc12 = new Bloc(4300, 210);

const tabObjets = [tuyauRouge1, tuyauRouge2, tuyauRouge3, tuyauRouge4, 
                    tuyauRouge5, tuyauRouge6, tuyauRouge7, tuyauRouge8, 
                    bloc1, bloc2, bloc3, bloc4, bloc5, bloc6, 
                    bloc7, bloc8, bloc9, bloc10, bloc11, bloc12];

const piece1 = new Piece(402, 145);
const piece2 = new Piece(1202, 140);
const piece3 = new Piece(1272, 95);
const piece4 = new Piece(1342, 40);
const piece5 = new Piece(1650, 145);
const piece6 = new Piece(2650, 145);
const piece7 = new Piece(3000, 135);
const piece8 = new Piece(3400, 125);
const piece9 = new Piece(4200, 145);
const piece10 = new Piece(4600, 40);

const tabPieces = [piece1, piece2, piece3, piece4, piece5,
                    piece6, piece7, piece8, piece9, piece10];                    

const champ1 = new Champ(800, 263);
const champ2 = new Champ(1100, 263);
const champ3 = new Champ(2100, 263);
const champ4 = new Champ(2400, 263);
const champ5 = new Champ(3200, 263);
const champ6 = new Champ(3500, 263);
const champ7 = new Champ(3700, 263);
const champ8 = new Champ(4500, 263);

const tabChamps = [champ1, champ2, champ3, champ4, champ5, champ6, champ7, champ8];

const tortue1 = new Tortue(950, 243);
const tortue2 = new Tortue(1500, 243);
const tortue3 = new Tortue(1800, 243);
const tortue4 = new Tortue(2400, 243);
const tortue5 = new Tortue(3100, 243);
const tortue6 = new Tortue(3600, 243);
const tortue7 = new Tortue(3900, 243);
const tortue8 = new Tortue(4200, 243);
const tortue9 = new Tortue(4400, 243);

const tabTortues = [tortue1, tortue2, tortue3, tortue4, tortue5, tortue6, tortue7, tortue8, 
                    tortue9];

export const scene = new Scene(cvs.width, cvs.height);
const clavier = new Clavier();
export const mario = new Mario(300, 245);

let nbrePiecesEncaissees = 0;
let tempsRestant = 100;
let compteurTemps = 0;
let finDePartie = false;
let joueSon = true;

// Dessin de l'écran
function dessine(){ 
    compteurTemps++;
    // Contacts de Mario
    // champignons
    for(let i=0; i<tabChamps.length; i++){
        if(mario.proche(tabChamps[i]) === true && tabChamps[i].vivant === true){
            mario.contactPersonnage(tabChamps[i]);
            if(tabChamps[i].vivant === false){
                sonEcrasePersonnage.play();
            }
        }
    }
    // tortues
    for(let i=0; i<tabTortues.length; i++){
        if(mario.proche(tabTortues[i]) === true && tabTortues[i].vivant === true){
            mario.contactPersonnage(tabTortues[i]);
            if(tabTortues[i].vivant === false){
                sonEcrasePersonnage.play();
            }
        }
    }
    // objets
    for(let i=0; i<tabObjets.length; i++){
        if(mario.proche(tabObjets[i])){
            mario.contact(tabObjets[i]);
        }
    }
    // pièce
    for(let i=0; i<tabPieces.length; i++){
        if(mario.proche(tabPieces[i]) === true){
            if(mario.contactPiece(tabPieces[i]) === true){
                tabPieces.splice(i, 1);
                sonPiece.play();
                nbrePiecesEncaissees++;
            }
        }
    }

    // Contact entre champignon et tortue
    for(let i=0; i<tabChamps.length; i++){
        for(let j=0; j<tabTortues.length; j++){
            if(tabChamps[i].proche(tabTortues[j]) === true){
                tabChamps[i].contact(tabTortues[j]);
                tabTortues[j].contact(tabChamps[i]);
            }
        }
    }

    // Contact des champignons avec les tuyaux
    for(let i=0; i<tabChamps.length; i++){
        for(let j=0; j<8; j++){
            if(tabChamps[i].proche(tabObjets[j]) === true){
                tabChamps[i].contact(tabObjets[j]);
            }
        }
    }

    // Contact des tortues avec les tuyaux
    for(let i=0; i<tabTortues.length; i++){
        for(let j=0; j<8; j++){
            if(tabTortues[i].proche(tabObjets[j]) === true){
                tabTortues[i].contact(tabObjets[j]);
            }
        }
    }

    // Déplacement des objets du jeu
    scene.deplacementFond(ctx);
    for(let i=0; i<tabObjets.length; i++){
        tabObjets[i].deplacement();
    }
    for(let i=0; i<tabPieces.length; i++){
        tabPieces[i].deplacement();
        tabPieces[i].bouge();
    }
    for(let i=0; i<tabChamps.length; i++){
        tabChamps[i].deplacement();
        tabChamps[i].bouge();
    }
    for(let i=0; i<tabTortues.length; i++){
        tabTortues[i].deplacement();
        tabTortues[i].bouge();
    }
    // Images des objets
    for(let i=0; i<tabObjets.length; i++){
        ctx.drawImage(tabObjets[i].imgObjet, tabObjets[i].x, tabObjets[i].y);
    }
    // Images des pièces
    for(let i=0; i<tabPieces.length; i++){
        ctx.drawImage(tabPieces[i].imgObjet, tabPieces[i].x, tabPieces[i].y);
    }
    // Images des champignons
    for(let i=0; i<tabChamps.length; i++){
        if(tabChamps[i].vivant === true){
            ctx.drawImage(tabChamps[i].marche("champ", 44), tabChamps[i].x, tabChamps[i].y);
        }else{
            ctx.drawImage(tabChamps[i].meurt(), tabChamps[i].x, tabChamps[i].y + 20);
        }
    }
    // Images des tortues
    for(let i=0; i<tabTortues.length; i++){
        if(tabTortues[i].vivant === true){
            ctx.drawImage(tabTortues[i].marche("tortue", 50), tabTortues[i].x, tabTortues[i].y);
        }else{
            ctx.drawImage(tabTortues[i].meurt(), tabTortues[i].x, tabTortues[i].y + 30);
        }
    }
    // Image de Mario
    if(mario.vivant === true){
        if(mario.saut === true){
            ctx.drawImage(mario.saute(), mario.x, mario.y);
        }else{
            ctx.drawImage(mario.marche("mario", 20), mario.x, mario.y);
        }
    }else{
        ctx.drawImage(mario.meurt(), mario.x, mario.y);
    }
    // Image du drapeau d'arrivée
    ctx.drawImage(scene.imgDrapeau, 4650 - scene.xPos, 115);
    // Image du château d'arrivée
    ctx.drawImage(scene.imgChateauFin, 5000 - scene.xPos, 145);
    // Fin de partie
    if(tempsRestant > 0 && mario.vivant === true && nbrePiecesEncaissees === 10 && scene.xPos > 4400){
        finDePartie = true;
        ctx.font = "60px Arial";
        ctx.fillText("Vous avez gagné !!", 120, 180);
        if(joueSon === true){
            musiqueFinGagne.play();
            joueSon = false;
        }  
    }else if(tempsRestant <= 0 || mario.vivant === false){
        finDePartie = true;
        ctx.font = "60px Arial";
        ctx.fillText("Vous avez perdu ...", 120, 180);
    }
    // Affichage des pièces encaissées
    ctx.font = "20px Arial";
    ctx.fillText(nbrePiecesEncaissees + " pièce(s) encaissée(s) sur 10", 420, 25);
    // Affichage du temps restant
    if(tempsRestant > 0){
        tempsRestant = 100 - Math.round(compteurTemps/100);
    }
    ctx.fillText("Temps restant : " + tempsRestant, 5, 25);
    ctx.lineWiidth = 3;
    ctx.strokeRect(0, 0, cvs.width, cvs.height);
    requestAnimationFrame(dessine);
}
dessine();
